Index: /branches/IslandALPS/IslandALPS/3.3/IslandALPSAlgorithm.cs
===================================================================
--- /branches/IslandALPS/IslandALPS/3.3/IslandALPSAlgorithm.cs	(revision 13722)
+++ /branches/IslandALPS/IslandALPS/3.3/IslandALPSAlgorithm.cs	(revision 13723)
@@ -381,5 +381,5 @@
       #region ALPSParameter
 
-      Parameters.Add(new ValueParameter<IntValue>("AgeGap", "The frequency of reseeding the lowest layer and scaling factor for the age-limits for the layers.", new IntValue(5)));
+      Parameters.Add(new ValueParameter<IntValue>("AgeGap", "The frequency of reseeding the lowest layer and scaling factor for the age-limits for the layers.", new IntValue(20)));
       Parameters.Add(new ValueParameter<DoubleValue>("AgeInheritance", "A weight that determines the age of a child after crossover based on the older (1.0) and younger (0.0) parent.", new DoubleValue(1)));
       Parameters.Add(new ValueParameter<IntArray>("AgeLimits", "The maximum age an individual is allowed to reach in a certain layer.", new IntArray(new int[0])) {Hidden = true});
@@ -387,5 +387,5 @@
       Parameters.Add(new ValueParameter<BoolValue>("ReduceToPopulationSize", ".", new BoolValue(true)));
 
-      Parameters.Add(new ValueParameter<IntValue>("NumberOfLayers", "", new IntValue(100000)));
+      Parameters.Add(new ValueParameter<IntValue>("NumberOfLayers", "", new IntValue(10000)));
       Parameters.Add(new ValueParameter<MultiAnalyzer>("LayerAnalyzer", "The operator used to analyze each layer.", new MultiAnalyzer()));
       Parameters.Add(new ValueParameter<MultiAnalyzer>("GroupAnalyzer", "The operator used to analyze each layergroup.", new MultiAnalyzer()));
Index: /branches/IslandALPS/IslandALPS/3.3/IslandAlpsAlgorithmMainLoop.cs
===================================================================
--- /branches/IslandALPS/IslandALPS/3.3/IslandAlpsAlgorithmMainLoop.cs	(revision 13722)
+++ /branches/IslandALPS/IslandALPS/3.3/IslandAlpsAlgorithmMainLoop.cs	(revision 13723)
@@ -268,5 +268,5 @@
       #endregion
 
-      globalVariableCreator.CollectedValues.Add(new ValueParameter<IntValue>(GenerationsParametername, new IntValue(0)));
+      globalVariableCreator.CollectedValues.Add(new ValueParameter<IntValue>(GenerationsParametername, new IntValue(1)));
       globalVariableCreator.CollectedValues.Add(new ValueParameter<IntValue>(MigrationsParametername, new IntValue(0)));
 
@@ -296,5 +296,5 @@
       incrementEvaluatedSolutionDr.TargetParameter.ActualName = EvaluatedSolutions.Name;
       incrementEvaluatedSolutionDr.ReductionOperation.Value = new ReductionOperation(ReductionOperations.Sum);
-      incrementEvaluatedSolutionDr.TargetOperation.Value = new ReductionOperation(ReductionOperations.Sum);
+      incrementEvaluatedSolutionDr.TargetOperation.Value = new ReductionOperation(ReductionOperations.Assign);
 
       setIslandEvaluatedSolutions.ParameterToReduce.ActualName = LayerEvaluatedSolutionsParameter.Name;
@@ -535,4 +535,5 @@
       var updateLayerNumber = new Assigner {Name = "Layer = OpenLayers"};
       var historyWiper = new ResultsHistoryWiper {Name = "Clear History in Results"};
+      var evaluatedSolutionsWiper = new Assigner() {Name = "Clear evaluated Solutions"};
       var createChildrenViaCrossover = new AlpsGeneticAlgorithmMainOperator();
       var incrEvaluatedSolutionsForNewLayer = new SubScopesCounter {Name = "Update EvaluatedSolutions"};
@@ -569,5 +570,8 @@
 
       historyWiper.ResultsParameter.ActualName = LayerResultsParametername;
-      historyWiper.Successor = createChildrenViaCrossover;
+      historyWiper.Successor = evaluatedSolutionsWiper;
+      evaluatedSolutionsWiper.LeftSideParameter.ActualName = LayerEvaluatedSolutionsParameterName;
+      evaluatedSolutionsWiper.RightSideParameter.Value = new IntValue(0);
+      evaluatedSolutionsWiper.Successor = createChildrenViaCrossover;
 
       // Maybe use only crossover and no elitism instead of "default operator"
Index: /branches/IslandALPS/IslandALPS/3.3/Offspring Selection/IslandAlpsOffspringSelectionAlgorithm.cs
===================================================================
--- /branches/IslandALPS/IslandALPS/3.3/Offspring Selection/IslandAlpsOffspringSelectionAlgorithm.cs	(revision 13722)
+++ /branches/IslandALPS/IslandALPS/3.3/Offspring Selection/IslandAlpsOffspringSelectionAlgorithm.cs	(revision 13723)
@@ -389,5 +389,5 @@
       #region ALPSParameter
 
-      Parameters.Add(new ValueParameter<IntValue>("AgeGap", "The frequency of reseeding the lowest layer and scaling factor for the age-limits for the layers.", new IntValue(5)));
+      Parameters.Add(new ValueParameter<IntValue>("AgeGap", "The frequency of reseeding the lowest layer and scaling factor for the age-limits for the layers.", new IntValue(20)));
       Parameters.Add(new ValueParameter<DoubleValue>("AgeInheritance", "A weight that determines the age of a child after crossover based on the older (1.0) and younger (0.0) parent.", new DoubleValue(1)));
       Parameters.Add(new ValueParameter<IntArray>("AgeLimits", "The maximum age an individual is allowed to reach in a certain layer.", new IntArray(new int[0])) {Hidden = true});
@@ -395,5 +395,5 @@
       Parameters.Add(new ValueParameter<BoolValue>("ReduceToPopulationSize", ".", new BoolValue(true)));
 
-      Parameters.Add(new ValueParameter<IntValue>("NumberOfLayers", "", new IntValue(100000)));
+      Parameters.Add(new ValueParameter<IntValue>("NumberOfLayers", "", new IntValue(10000)));
       Parameters.Add(new ValueParameter<MultiAnalyzer>("LayerAnalyzer", "The operator used to analyze each layer.", new MultiAnalyzer()));
       Parameters.Add(new ValueParameter<MultiAnalyzer>("GroupAnalyzer", "The operator used to analyze each layergroup.", new MultiAnalyzer()));
Index: /branches/IslandALPS/IslandALPS/3.3/Offspring Selection/IslandAlpsOffspringSelectionAlgorithmMainLoop.cs
===================================================================
--- /branches/IslandALPS/IslandALPS/3.3/Offspring Selection/IslandAlpsOffspringSelectionAlgorithmMainLoop.cs	(revision 13722)
+++ /branches/IslandALPS/IslandALPS/3.3/Offspring Selection/IslandAlpsOffspringSelectionAlgorithmMainLoop.cs	(revision 13723)
@@ -294,5 +294,5 @@
       #endregion
 
-      globalVariableCreator.CollectedValues.Add(new ValueParameter<IntValue>(GenerationsParametername, new IntValue(0)));
+      globalVariableCreator.CollectedValues.Add(new ValueParameter<IntValue>(GenerationsParametername, new IntValue(1)));
       globalVariableCreator.CollectedValues.Add(new ValueParameter<IntValue>(MigrationsParametername, new IntValue(0)));
 
@@ -322,5 +322,5 @@
       incrementEvaluatedSolutionDr.TargetParameter.ActualName = EvaluatedSolutions.Name;
       incrementEvaluatedSolutionDr.ReductionOperation.Value = new ReductionOperation(ReductionOperations.Sum);
-      incrementEvaluatedSolutionDr.TargetOperation.Value = new ReductionOperation(ReductionOperations.Sum);
+      incrementEvaluatedSolutionDr.TargetOperation.Value = new ReductionOperation(ReductionOperations.Assign);
 
       setIslandEvaluatedSolutions.ParameterToReduce.ActualName = LayerEvaluatedSolutionsParameter.Name;
@@ -577,4 +577,5 @@
       var updateLayerNumber = new Assigner {Name = "Layer = OpenLayers"};
       var historyWiper = new ResultsHistoryWiper {Name = "Clear History in Results"};
+      var evaluatedSolutionsWiper = new Assigner() { Name = "Clear evaluated Solutions" };
       var createChildrenViaCrossover = new AlpsOffspringSelectionGeneticAlgorithmMainOperator();
       var incrEvaluatedSolutionsForNewLayer = new SubScopesCounter {Name = "Update EvaluatedSolutions"};
@@ -612,5 +613,8 @@
 
       historyWiper.ResultsParameter.ActualName = "LayerResults";
-      historyWiper.Successor = createChildrenViaCrossover;
+      historyWiper.Successor = evaluatedSolutionsWiper;
+      evaluatedSolutionsWiper.LeftSideParameter.ActualName = LayerEvaluatedSolutionsParameterName;
+      evaluatedSolutionsWiper.RightSideParameter.Value = new IntValue(0);
+      evaluatedSolutionsWiper.Successor = createChildrenViaCrossover;
 
       // Maybe use only crossover and no elitism instead of "default operator"