Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs	(revision 13714)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs	(revision 13733)
@@ -8,23 +8,38 @@
 namespace HeuristicLab.Clients.Hive.WebJobManager.Controllers
 {
+    /// <summary>
+    /// Controller for initial landing page
+    /// </summary>
     public class HomeController : Controller
     {
-        private ILoginViewModelService loginViewModelService;
+        private LoginViewModelService loginViewModelService;
         private HiveServiceClient client;
         public HomeController(ILoginViewModelService loginViewModelService)
         {
-            this.loginViewModelService = loginViewModelService;
+            this.loginViewModelService = (LoginViewModelService)loginViewModelService;
         }
+        #region Login
+        /// <summary>
+        /// Opens initial home page
+        /// </summary>
+        /// <returns>View from home page</returns>
         public IActionResult Index()
         {
             ViewBag.Title = "Login";
+            loginViewModelService.clear();
             return View(loginViewModelService.GetLoginViewModel());
         }
-        public IActionResult Login(string loginName, string password)
+        /// <summary>
+        /// Checks login
+        /// </summary>
+        /// <param name="loginName">Login name</param>
+        /// <param name="password">Login password</param>
+        /// <returns>Logged in view if correct or shows error</returns>
+        public IActionResult Login(string loginName, string password)//Checks login
         {
             if (!string.IsNullOrEmpty(loginName) && !string.IsNullOrEmpty(password))
             {
                 var model = loginViewModelService.GetLoginViewModel();
-                HiveServiceLocatorWebManagerService hiveServiceLocator = (HiveServiceLocatorWebManagerService)HiveServiceLocatorWebManagerService.Instance;
+                HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
                 HeuristicLab.Clients.Common.Properties.Settings.Default.UserName = loginName;
                 HeuristicLab.Clients.Common.Properties.Settings.Default.Password = Common.CryptoService.EncryptString(password);
@@ -37,5 +52,6 @@
                     var test = client.GetJobs();//Throws messageSecurityException if login failss
                     ViewBag.Title = "Login succesful";
-                    return View("LoginHome");
+                    
+                    return RedirectToAction("Index","Job");
                 }
                 catch(MessageSecurityException e)
@@ -55,4 +71,9 @@
             }
         }
+        public IActionResult Logout()
+        {
+            return RedirectToAction("Index","Home");
+        }
+        #endregion
     }
 }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs	(revision 13714)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs	(revision 13733)
@@ -18,4 +18,7 @@
 namespace HeuristicLab.Clients.Hive.WebJobManager.Controllers
 {
+    /// <summary>
+    /// Controller for everything Job related (includes uploads and uploader)
+    /// </summary>
     public class JobController : Controller
     {
@@ -26,5 +29,5 @@
         public JobController(IHostingEnvironment env)
         {
-            HiveServiceLocatorWebManagerService hiveServiceLocator = (HiveServiceLocatorWebManagerService)HiveServiceLocatorWebManagerService.Instance;
+            HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
             client = hiveServiceLocator.getHiveServiceClient();
             vm = new JobViewModel();
@@ -34,4 +37,8 @@
         }
         #region Jobs
+        /// <summary>
+        /// initial job page, shows all jobs
+        /// </summary>
+        /// <returns></returns>
         public IActionResult Index()
         {
@@ -46,5 +53,5 @@
                 if (e is MessageSecurityException || e is InvalidOperationException)
                 {
-                    HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
+                    HiveServiceLocatorWeb.SetLoginErrorMessage();
                     return RedirectToAction("Index", "Home");
                 }
@@ -54,7 +61,12 @@
             return View(vm);
         }
+        /// <summary>
+        /// Initial page and a selected job
+        /// </summary>
+        /// <param name="id">Job id selected</param>
+        /// <returns></returns>
         public IActionResult Selected(Guid id)
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
                 HiveClientWeb.Instance.Refresh();
@@ -77,11 +89,16 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
-                return RedirectToAction("Index", "Home");
-            }
-        }
-        public IActionResult Delete(Guid id)// delete a job
-        {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// Deletes a job
+        /// </summary>
+        /// <param name="id">Job id</param>
+        /// <returns></returns>
+        public IActionResult Delete(Guid id)
+        {
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
 
@@ -96,5 +113,5 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -103,11 +120,15 @@
 
         #region Uploads
+        /// <summary>
+        /// Shows the uploaded directories
+        /// </summary>
+        /// <returns></returns>
         public IActionResult Uploads()
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
                 fillUploadsPaths(upper, -1);
-
+                ViewBag.Name = client.ClientCredentials.UserName.UserName;
                 ViewBag.Title = "Uploaded files";
                 return View("Uploads", upper);
@@ -115,11 +136,16 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
-                return RedirectToAction("Index", "Home");
-            }
-        }
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// //Shows content of selected dir
+        /// </summary>
+        /// <param name="index">Array index selected directory</param>
+        /// <returns></returns>
         public IActionResult UploadDir(int index)
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
@@ -131,9 +157,15 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
-                return RedirectToAction("Index", "Home");
-            }
-        }
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// Loads all the paths from the selected uploads folder
+        /// </summary>
+        /// <param name="vm">Viewmodel to save every directory path</param>
+        /// <param name="index">Index selected directory</param>
         private void fillUploadsPaths(UploadedJobViewModel vm, int index)
+            
         {
             var tempdex = index; //Fix when maps gets deleted
@@ -165,7 +197,13 @@
             }
         }
+        /// <summary>
+        /// Deletes a file
+        /// </summary>
+        /// <param name="index">Index directory</param>
+        /// <param name="filedex">Index file to delete</param>
+        /// <returns></returns>
         public IActionResult DeleteFile(int index, int filedex)
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
@@ -183,12 +221,17 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
-                return RedirectToAction("Index", "Home");
-            }
-        }
-
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// Opens a selected file
+        /// </summary>
+        /// <param name="index">Index directory</param>
+        /// <param name="filedex">Index selected file</param>
+        /// <returns></returns>
         public IActionResult OpenFile(int index, int filedex)
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
@@ -221,12 +264,15 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
-                return RedirectToAction("Index", "Home");
-            }
-        }
-
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
+                return RedirectToAction("Index", "Home");
+            }
+        }
+        /// <summary>
+        /// Adds current opened file to hive, uses FileOpeningService singleton
+        /// </summary>
+        /// <returns></returns>
         public IActionResult AddToHive()
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
                     var job = FileOpeningService.Instance.AddCurrentModelToHive();
@@ -241,5 +287,5 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -248,5 +294,5 @@
         /* public async Task<IActionResult> DownloadFile(int index, int filedex)
          {
-             if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+             if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
              {
                  UploadedJobViewModel upper = new UploadedJobViewModel();
@@ -269,5 +315,5 @@
              else
              {
-                 HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
+                 HiveServiceLocatorWeb.SetLoginErrorMessage();
                  return RedirectToAction("Index", "Home");
              }
@@ -277,18 +323,11 @@
 
         #region Uploader
-        public IActionResult Uploader()
-        {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
-            {
-                ViewBag.Title = "Upload Jobs";
-                ViewBag.Name = client.ClientCredentials.UserName.UserName;
-                return View("Uploader");
-            }
-            else
-            {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
-                return RedirectToAction("Index", "Home");
-            }
-        }
+
+        /// <summary>
+        /// Uploads file onto server directory
+        /// </summary>
+        /// <param name="files">Files</param>
+        /// <param name="directory">Directory path for server</param>
+        /// <returns></returns>
         [HttpPost]
         public async Task<IActionResult> Uploader(ICollection<IFormFile> files, string directory)
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs	(revision 13714)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs	(revision 13733)
@@ -17,5 +17,5 @@
         public ResourceController(IHostingEnvironment env)
         {
-            HiveServiceLocatorWebManagerService hiveServiceLocator = (HiveServiceLocatorWebManagerService)HiveServiceLocatorWebManagerService.Instance;
+            HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
             client = hiveServiceLocator.getHiveServiceClient();
 
@@ -24,5 +24,5 @@
         public IActionResult Index()
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
 
@@ -32,5 +32,5 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs	(revision 13714)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs	(revision 13733)
@@ -17,5 +17,5 @@
         public UserController(IHostingEnvironment env)
         {
-            HiveServiceLocatorWebManagerService hiveServiceLocator = (HiveServiceLocatorWebManagerService)HiveServiceLocatorWebManagerService.Instance;
+            HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
             client = hiveServiceLocator.getHiveServiceClient();
 
@@ -24,5 +24,5 @@
         public IActionResult Index()
         {
-            if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
+            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
             {
                 
@@ -32,5 +32,5 @@
             else
             {
-                HiveServiceLocatorWebManagerService.SetLoginErrorMessage();
+                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }