Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13739)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13740)
@@ -26,8 +26,5 @@
         @Model.message
     </div>
-    <div class="row"
-         style="margin:10px">
 
-    </div>
     <div class="row"
          style="padding:10px; margin-right:0px!important">
@@ -77,93 +74,92 @@
             </p>
 
-                <div class="col-sm-8"
-                     id="content"
-                     style="padding:5px; padding-left:10px;">
-                    @if (Model.selectedJob != null)
+            <div class="col-sm-8"
+                 id="content"
+                 style="padding:5px; padding-left:10px;">
+                @if (Model.selectedJob != null)
                 {
-                        <div class="panel panel-default"
-                             style="border-width:2px!important;padding:17px;
+                    <div class="panel panel-default"
+                         style="border-width:2px!important;padding:17px;
                         box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);">
-                            <div class="row">
-                                <h2 style="padding-left:20px">
-                                    @Model.selectedJob.Job.Name
-                                    <a onclick="popUpDelete()"
-                                       style="margin-bottom:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                        <div class="row">
+                            <h2 style="padding-left:20px">
+                                @Model.selectedJob.Job.Name
+                                <a onclick="popUpDelete()"
+                                   style="margin-bottom:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                                     text-shadow:2px 2px black;"
-                                       class='btn btn-danger'>
-                                        <span class="glyphicon glyphicon-trash"
-                                              aria-hidden="true"></span>
-                                        Delete job
-                                    </a>
-                                    <a style="display:none; "
-                                       asp-action="Delete"
-                                       asp-route-id="@Model.selectedJob.Id"
-                                       asp-controller="Job" id="del"
-                                       onclick="showDeleter()"></a>
+                                   class='btn btn-danger'>
+                                    <span class="glyphicon glyphicon-trash"
+                                          aria-hidden="true"></span>
+                                    Delete job
+                                </a>
+                                <a style="display:none; "
+                                   asp-action="Delete"
+                                   asp-route-id="@Model.selectedJob.Id"
+                                   asp-controller="Job" id="del"
+                                   onclick="showDeleter()"></a>
 
-                                    <script type="text/javascript">
-                                        function popUpDelete() {
-                                            if (confirm("Are you sure you want to delete this job?") == true) {
-                                                document.getElementById("del").click();
-                                            }
+                                <script type="text/javascript">
+                                    function popUpDelete() {
+                                        if (confirm("Are you sure you want to delete this job?") == true) {
+                                            document.getElementById("del").click();
+                                        }
 
-                                        }
-                                    </script>
+                                    }
+                                </script>
 
-                                </h2>
-                                <div class="col-sm-6" style="padding-left:30px">
-                                    <p>Description: @Model.selectedJob.Job.Description</p>
-                                    <p>Resources: @Model.selectedJob.Job.ResourceNames</p>
-                                    <p>Created: @Model.selectedJob.Job.DateCreated</p>
-                                    <p>Owned by: @Model.selectedJob.Job.OwnerUsername</p>
-
-                                </div>
-                                <div class="col-sm-6" style="padding-left:30px">
-                                    <p id="jobcalculating">
-                                        Calculating: @Model.selectedJob.Job.CalculatingCount
-                                    </p>
-                                    <p id="jobfinished">
-                                        Finished: @Model.selectedJob.Job.FinishedCount
-                                    </p>
-                                    <p>
-                                        Automatic refresh:
-                                        <input type="checkbox"
-                                               checked
-                                               data-toggle="toggle"
-                                               data-onstyle="success"
-                                               id="refreshtogg"
-                                               onchange="autoRefresh()" />
-                                    </p>
-                                </div>
+                            </h2>
+                            <div class="col-sm-6" style="padding-left:30px">
+                                <p>Description: @Model.selectedJob.Job.Description</p>
+                                <p>Resources: @Model.selectedJob.Job.ResourceNames</p>
+                                <p>Created: @Model.selectedJob.Job.DateCreated</p>
+                                <p>Owned by: @Model.selectedJob.Job.OwnerUsername</p>
 
                             </div>
+                            <div class="col-sm-6" style="padding-left:30px">
+                                <p id="jobcalculating">
+                                    Calculating: @Model.selectedJob.Job.CalculatingCount
+                                </p>
+                                <p id="jobfinished">
+                                    Finished: @Model.selectedJob.Job.FinishedCount
+                                </p>
+                                <p>
+                                    Automatic refresh:
+                                    <input type="checkbox"
+                                           checked
+                                           data-toggle="toggle"
+                                           data-onstyle="success"
+                                           id="refreshtogg"
+                                           onchange="autoRefresh()" />
+                                </p>
+                            </div>
 
-                            <script src="~/js/scripts/graphs/graphdatacollector.js"></script>
-                            <script src="~/js/scripts/graphs/graphhubber.js"></script>
-                            <div class="row" style="text-align:center">
-                                @Html.Partial("_Graphlegend")
-                                <div id="graphMain" style="width:100%;height:0px">
+                        </div>
+                        <script src="~/js/scripts/graphs/graphdatacollector.min.js"></script>
+                        <script src="~/js/scripts/graphs/graphhubber.min.js"></script>
+                        <div class="row" style="text-align:center">
+                            @Html.Partial("_Graphlegend")
+                            <div id="graphMain" style="width:100%;height:0px">
 
-                                </div>
-                                <div class="btn btn-lg btn-info"
-                                     onclick="redrawMain()"
-                                     style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            </div>
+                            <div class="btn btn-lg btn-info"
+                                 onclick="redrawMain()"
+                                 style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;">Refresh main graph</div>
-                            </div>
-                            <div class="row">
-                                <h3 style="padding-left:20px; ">
-                                    @Model.selectedJob.Job.JobCount Tasks
-                                </h3>
-                                @foreach (var task in Model.selectedJob.HiveTasks)
-                                {
-                                    @Html.Partial("SelectedJobPartials/_TaskPartial",
+                        </div>
+                        <div class="row">
+                            <h3 style="padding-left:20px; ">
+                                @Model.selectedJob.Job.JobCount Tasks
+                            </h3>
+                            @foreach (var task in Model.selectedJob.HiveTasks)
+                            {
+                                @Html.Partial("SelectedJobPartials/_TaskPartial",
                            new HeuristicLab.Clients.Hive.WebJobManager.Models.HiveTaskContainer(task))
 
-                                }
-                            </div>
+                            }
                         </div>
-                    }
-                </div>
-                
+                    </div>
+                }
+            </div>
+
 
         }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13739)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13740)
@@ -87,5 +87,5 @@
                      style="text-align:right">
                     <h5>
-                        Resource
+                        Resources (optional)
                     </h5>
                 </div>
@@ -94,12 +94,9 @@
                     <div class="form-group">
                         <div class="input-group">
-                            <div class="input-group-addon">
-                                HEAL/
-                            </div>
                             <input type="text"
                                    class="form-control"
                                    name="jresource"
                                    id="jresource"
-                                   placeholder="Resource (optional)">
+                                   placeholder="(seperate with ;)">
                         </div>
                     </div>
@@ -176,6 +173,6 @@
             {
                 <li><a id="ctasks" href="#tasks">Child tasks </a></li>
-                <li><a onclick="shower()"><i class="fa fa-eye"></i> Show all tasks</a></li>
-                <li><a onclick="collapser()"><i class="fa fa-eye-slash"></i> Hide all tasks</a></li>
+                <li><a onclick="shower()" href="#tasks"><i class="fa fa-eye"></i> Show all tasks</a></li>
+                <li><a onclick="collapser()" href="#tasks"><i class="fa fa-eye-slash"></i> Hide all tasks</a></li>
                 
             }
@@ -183,6 +180,7 @@
         </ul>
     </nav>
+
+    <script src="~/js/scripts/hubber.min.js"></script>
     
-    <script src="~/js/scripts/hubber.js"></script>
     <script>
         showScrolly = function () {
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/SelectedJobPartials/_BatchTask.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/SelectedJobPartials/_BatchTask.cshtml	(revision 13739)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/SelectedJobPartials/_BatchTask.cshtml	(revision 13740)
@@ -21,5 +21,5 @@
             <thead>
                 <tr>
-                    <th>Batch run: @Model.hiveTask.ItemTask.Name</th>
+                    <th> Batch run: @Model.hiveTask.ItemTask.Name</th>
                     <th style="font-size:large; ">
                         @if (Model.hiveTask.Task.Priority == 0)
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/SelectedJobPartials/_TaskPartial.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/SelectedJobPartials/_TaskPartial.cshtml	(revision 13739)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/SelectedJobPartials/_TaskPartial.cshtml	(revision 13740)
@@ -1,5 +1,4 @@
 ﻿@model HeuristicLab.Clients.Hive.WebJobManager.Models.HiveTaskContainer
 
-        
 
         @if (Model.hiveTask.ItemTask.Item is HeuristicLab.Optimization.IAlgorithm)
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml	(revision 13739)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml	(revision 13740)
@@ -1,5 +1,3 @@
 ﻿
-
-
 <div class="panel panel-default"
      style="border-width:2px!important;padding:17px;
@@ -19,5 +17,5 @@
              class="btn btn-info btn-lg btn-block"
              style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
-                            text-shadow:2px 2px black;">
+                            text-shadow:1px 1px black;">
             <i class="fa fa-folder-open-o"></i> Choose file(s) to upload to the server
         </div>